
libname gagnon '~/hogsett/coop/gagnon';
filename gsasfile pipe 'lpr -h -G -Pps';
goptions  gaccess=gsasfile;
data gagnon.clon1991;
  infile '~/hogsett/coop/gagnon/clon1991.prn';
  input  TRT CH CLONE clone_NO LEAF STEM ROOT HT0 NLeaf0 DIAM0 HT1 NLeaf1 Drop1 DIAM1 HT2 NLeaf2 Drop2 DIAM2 HT3 NLeaf3 Drop3 DIAM3
  ht4 nleaf4 drop4 diam4;
  if ht0=-99 then ht0=.;
  if ht1=-99 then ht1=.;
  if ht2=-99 then ht2=.;
  if ht3=-99 then ht3=.;
  if ht4=-99 then ht4=.;
  if diam1=-99 then diam1=.;
  if diam2=-99 then diam2=.;
  if diam3=-99 then diam3=.;
  if diam0=-99 then diam0=.;
  if diam4=-99 then diam4=.;
  if nleaf0=-99 then nleaf0=.;
  if nleaf1=-99 then nleaf1=.;
  if nleaf2=-99 then nleaf2=.;
  if nleaf3=-99 then nleaf3=.;
  if nleaf4=-99 then nleaf4=.;
  if drop1=-99 then drop1=.;
  if drop2=-99 then drop2=.;
  if drop3=-99 then drop3=.;
  if drop4=-99 then drop4=.;
  if leaf=-99 then leaf=.;
  if stem=-99 then stem=.;
  if root=-99 then root=.;
  if trt=1 and ch=11 and leaf=11.45 then nleaf3=29;
  if trt=2 and ch=2 and leaf=11.74 then diam0=4.7;
  if trt=5 and ch=13 and leaf=6.75 then drop1=1;
  if trt=1 and ch=11 and leaf=8.56 then root=20;

proc contents data=gagnon.clon1991;
proc freq;
 tables ch*trt  ch*clone trt*clone ;
proc means data=gagnon.clon1991;
   var HT0 HT1 HT2 HT3 ht4 DIAM0 DIAM1 DIAM2 DIAM3 diam4 NLEAF0 NLEAF1 NLEAF2 NLEAF3 nleaf4 DROP1 DROP2 DROP3 drop4 leaf stem root;
run;
