library(tidyverse)
library(lubridate)
library(hms)
library(RColorBrewer)

# Read in the OZ data ---------------------------------------------------
ch1 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch01.csv")
ch2 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch02.csv")
ch3 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch03.csv")
ch4 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch04.csv")
ch5 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch05.csv")
ch6 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch06.csv")
ch7 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch07.csv")
ch8 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch08.csv")
ch9 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/88ch09.csv")
ch10 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/topen88.csv")
ch11 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/topen88.csv")
ch12 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1988/topen88.csv")

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/clean_chamber.R")

CH1 <- clean_chamber(ch1, 1988)    
CH2 <- clean_chamber(ch2, 1988)       
CH3 <- clean_chamber(ch3, 1988)         
CH4 <- clean_chamber(ch4, 1988)         
CH5 <- clean_chamber(ch5, 1988)         
CH6 <- clean_chamber(ch6, 1988)          
CH7 <- clean_chamber(ch7, 1988)          
CH8 <- clean_chamber(ch8, 1988)          
CH9 <- clean_chamber(ch9, 1988)         
CH10 <- clean_chamber(ch10, 1988)
CH11 <- clean_chamber(ch11, 1988)      
CH12 <- clean_chamber(ch12, 1988)      


oz_data <- full_join(CH1, CH2) %>% 
  full_join(CH3) %>% 
  full_join(CH4) %>% 
  full_join(CH5) %>% 
  full_join(CH6) %>% 
  full_join(CH7) %>% 
  full_join(CH8) %>% 
  full_join(CH9) %>% 
  full_join(CH10) %>% 
  full_join(CH11) %>% 
  full_join(CH12) %>% 
  mutate(Chamber = as_factor(Chamber))

oz_data %>% group_by(Chamber) %>% summarize(mean_ozone = mean(OZ, na.rm = TRUE))

oz_data %>% group_by(Chamber) %>% summarize(w126 = sum((OZ/1000)/(1 + 4403*exp(-126*(OZ/1000))), na.rm = TRUE))

#

oz_data %>% 
  ggplot() + 
  aes(x = Datetime, y = OZ/1000, color = Chamber) + 
  geom_line() + 
  facet_wrap(. ~ Chamber, nrow = 3) + 
  guides(color = FALSE)

# Some of these need to be set to missing because they are erroneous

o <- oz_data %>% 
  mutate(OZ = ifelse(between(Julian, 182, 186) |  
      (Julian == 187 & Hour <= hms(11)) |
      (Julian == 190 & between(Hour, hms(hours = 13), hms(hours = 16))) | 
      (Julian == 193 & between(Hour, hms(hours = 11), hms(hours = 14))) | 
      (Julian == 200 & between(Hour, hms(hours = 16), hms(hours = 17))) | 
      (Chamber %in% c(1, 2, 6) & Julian == 204 & Hour == hms(hours = 21)) |
      (Julian == 209 | between(Hour, hms(hours = 12), hms(hours = 16))) |
      (Julian == 216 & Hour >= hms(hours = 12)) |
      (Julian == 217 & Hour <= hms(hours = 16)) |
      (Chamber %in% c(1, 2, 6, 4, 5, 9) & Julian == 223 & Hour == hms(hours = 17)),
    NA, OZ)) 

o %>% group_by(Chamber) %>% summarise(mean_oz = mean(OZ, na.rm = TRUE))
o %>% group_by(Chamber) %>% summarize(w126 = sum((OZ/1000)/(1 + 4403*exp(-126*(OZ/1000))), na.rm = TRUE))

oz_data %>% 
  ggplot() + 
  aes(x = Datetime, y = OZ/1000) + 
  geom_line() + 
  geom_line(data = o, aes(x = Datetime, y = OZ/1000), color = "red") + 
  facet_wrap(. ~ Chamber, nrow = 3)

#write.csv(o, "1988_oz.csv", row.names = FALSE)

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/OZ_metrics_Neufeld.R")

exp_days <- as.numeric(max(o$Date) - min(o$Date) + 1)

oz_metrics <- OZ_metrics_neufeld(o) %>% 
  mutate_if(is.numeric, function(x){x * 92/exp_days})

#write.csv(oz_metrics, "1988_oz_metrics.csv", row.names = FALSE)

oz_data %>% filter(between(Date, mdy("07/01/1988"), mdy("08/24/1988"))) %>% group_by(Chamber) %>% summarise(mean(is.na(OZ)))
o %>% filter(between(Date, mdy("07/01/1988"), mdy("08/24/1988"))) %>% group_by(Chamber) %>% summarise(round(mean(is.na(OZ)), 3)*100)
