library(tidyverse)
library(lubridate)
library(hms)
library(RColorBrewer)

# Read in the OZ data ---------------------------------------------------
ch1 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch01.csv")
ch2 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch02.csv")
ch3 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch03.csv")
ch4 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch04.csv")
ch5 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch05.csv")
ch6 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch06.csv")
ch7 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch07.csv")
ch8 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch08.csv")
ch9 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/89ch09.csv")
ch10 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/topen89.csv")
ch11 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/topen89.csv")
ch12 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1989/topen89.csv")


source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/clean_chamber.R")

CH1 <- clean_chamber(ch1, 1989)    
CH2 <- clean_chamber(ch2, 1989)       
CH3 <- clean_chamber(ch3, 1989)         
CH4 <- clean_chamber(ch4, 1989)         
CH5 <- clean_chamber(ch5, 1989)         
CH6 <- clean_chamber(ch6, 1989)          
CH7 <- clean_chamber(ch7, 1989)          
CH8 <- clean_chamber(ch8, 1989)          
CH9 <- clean_chamber(ch9, 1989)
CH10 <- clean_chamber(ch10, 1989)         
CH11 <- clean_chamber(ch11, 1989)         
CH12 <- clean_chamber(ch12, 1989)         


oz_data <- full_join(CH1, CH2) %>% 
  full_join(CH3) %>% 
  full_join(CH4) %>% 
  full_join(CH5) %>% 
  full_join(CH6) %>% 
  full_join(CH7) %>% 
  full_join(CH8) %>% 
  full_join(CH9) %>% 
  full_join(CH10) %>% 
  full_join(CH11) %>% 
  full_join(CH12) %>% 
  mutate(Chamber = as_factor(Chamber))

summary(oz_data$Date)

oz_data %>% 
  ggplot() + 
  aes(x = Datetime, y = OZ/1000, color = Chamber) + 
  geom_line() + 
  facet_wrap(. ~ Chamber, nrow = 3) + 
  scale_color_manual(values = brewer.pal(9, "Set1")) + 
  guides(color = FALSE)

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/OZ_metrics_Neufeld.R")

exp_days <- max(oz_data$Julian) - min(oz_data$Julian) + 1

oz_metrics <- OZ_metrics_neufeld(oz_data) %>% 
  mutate_if(is.numeric, function(x){x * 92/exp_days})

#write.csv(oz_data, "1989_oz.csv", row.names = FALSE)
#write.csv(oz_metrics, "1989_oz_metrics.csv", row.names = FALSE)

oz_data %>% 
  ggplot(aes(x = Chamber, y = log10(OZ))) + 
  geom_boxplot()

oz_data %>% group_by(Chamber) %>% summarise(m = mean(is.na(OZ))) %>% arrange(desc(m))

