library(tidyverse)
library(lubridate)
library(hms)
library(RColorBrewer)

# Read in the OZ data ---------------------------------------------------
ch1 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch01.csv")
ch2 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch02.csv")
ch3 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch03.csv")
ch4 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch04.csv")
ch5 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch05.csv")
ch6 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch06.csv")
ch7 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch07.csv")
ch8 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch08.csv")
ch9 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch09.csv")
ch10 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch10.csv")
ch11 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch11.csv")
ch12 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch12.csv")
ch13 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch13.csv")
ch14 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch14.csv")
ch15 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch15.csv")
ch16 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch16.csv")
ch17 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch17.csv")
ch18 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1990/90ch18.csv")

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/clean_chamber.R")

CH1 <- clean_chamber(ch1, 1990) 
CH2 <- clean_chamber(ch2, 1990)        
CH3 <- clean_chamber(ch3, 1990)         
CH4 <- clean_chamber(ch4, 1990)          
CH5 <- clean_chamber(ch5, 1990)         
CH6 <- clean_chamber(ch6, 1990)          
CH7 <- clean_chamber(ch7, 1990)         
CH8 <- clean_chamber(ch8, 1990)         
CH9 <- clean_chamber(ch9, 1990) 
CH10 <- clean_chamber(ch10, 1990)         
CH11 <- clean_chamber(ch11, 1990)          
CH12 <- clean_chamber(ch12, 1990)        
CH13 <- clean_chamber(ch13, 1990)          
CH14 <- clean_chamber(ch14, 1990)          
CH15 <- clean_chamber(ch15, 1990)          
CH16 <- clean_chamber(ch16, 1990)         
CH17 <- clean_chamber(ch17, 1990)          
CH18 <- clean_chamber(ch18, 1990)         

oz_data <- full_join(CH1, CH2) %>% 
  full_join(CH3) %>% 
  full_join(CH4) %>% 
  full_join(CH5) %>% 
  full_join(CH6) %>% 
  full_join(CH7) %>% 
  full_join(CH8) %>% 
  full_join(CH9) %>% 
  full_join(CH10) %>% 
  full_join(CH11) %>% 
  full_join(CH12) %>% 
  full_join(CH13) %>% 
  full_join(CH14) %>% 
  full_join(CH15) %>% 
  full_join(CH16) %>% 
  full_join(CH17) %>%
  full_join(CH18) %>% 
  mutate(Chamber = as_factor(Chamber))

summary(oz_data$Date)

#write.csv(oz_data, "oz_90_data.csv", row.names = FALSE)

oz_data  %>% 
  ggplot() + 
  aes(x = Datetime, y = OZ/1000, color = Chamber) + 
  geom_line() + 
  facet_wrap(. ~ Chamber, nrow = 3) + 
  guides(color = FALSE)

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/OZ_metrics_Neufeld.R")

exp_days <- max(oz_data$Julian) - min(oz_data$Julian) + 1

oz_metrics <- OZ_metrics_neufeld(oz_data) %>% 
  mutate_if(is.numeric, function(x){x * 92/exp_days})

#write.csv(oz_metrics, "1990_oz_metrics.csv", row.names = FALSE)

oz_data %>% 
  ggplot(aes(x = Chamber, y = log10(OZ))) + 
  geom_boxplot()


