library(tidyverse)
library(lubridate)
library(hms)
library(RColorBrewer)

# Read in the OZ data ---------------------------------------------------
ch1 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch01.csv")
ch2 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch02.csv")
ch3 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch03.csv")
ch4 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch04.csv")
ch5 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch05.csv")
ch6 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch06.csv")
ch7 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch07.csv")
ch8 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch08.csv")
ch9 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch09.csv")
ch10 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch10.csv")
ch11 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch11.csv")
ch12 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch12.csv")
ch13 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch13.csv")
ch14 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch14.csv")
ch15 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch15.csv")
ch16 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch16.csv")
ch17 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch17.csv")
ch18 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1991/91ch18.csv")

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/clean_chamber.R")

CH1 <- clean_chamber(ch1, 1991) 
CH2 <- clean_chamber(ch2, 1991)         
CH3 <- clean_chamber(ch3, 1991)       
CH4 <- clean_chamber(ch4, 1991)       
CH5 <- clean_chamber(ch5, 1991)        
CH6 <- clean_chamber(ch6, 1991)        
CH7 <- clean_chamber(ch7, 1991)       
CH8 <- clean_chamber(ch8, 1991)      
CH9 <- clean_chamber(ch9, 1991) 
CH10 <- clean_chamber(ch10, 1991)          
CH11 <- clean_chamber(ch11, 1991)          
CH12 <- clean_chamber(ch12, 1991)      
CH13 <- clean_chamber(ch13, 1991)          
CH14 <- clean_chamber(ch14, 1991)      
CH15 <- clean_chamber(ch15, 1991)        
CH16 <- clean_chamber(ch16, 1991)         
CH17 <- clean_chamber(ch17, 1991)         
CH18 <- clean_chamber(ch18, 1991)          

oz_data <- full_join(CH1, CH2) %>% 
  full_join(CH3) %>% 
  full_join(CH4) %>% 
  full_join(CH5) %>% 
  full_join(CH6) %>% 
  full_join(CH7) %>% 
  full_join(CH8) %>% 
  full_join(CH9) %>% 
  full_join(CH10) %>% 
  full_join(CH11) %>% 
  full_join(CH12) %>% 
  full_join(CH13) %>% 
  full_join(CH14) %>% 
  full_join(CH15) %>% 
  full_join(CH16) %>% 
  full_join(CH17) %>%
  full_join(CH18) %>% 
  mutate(Chamber = as_factor(Chamber))

#write.csv(oz_data, "oz_91_data.csv", row.names = FALSE)

oz_data %>% 
  ggplot() + 
  aes(x = Datetime, y = OZ/1000, color = Chamber) + 
  geom_line() + 
  facet_wrap(. ~ Chamber, nrow = 3) + 
  guides(color = FALSE)

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/OZ_metrics_Neufeld.R")

exp_days <- max(oz_data$Julian) - min(oz_data$Julian) + 1

oz_metrics <- OZ_metrics_neufeld(oz_data) %>% 
  mutate_if(is.numeric, function(x){x * 92/exp_days})

#write.csv(oz_metrics, "1991_oz_metrics.csv", row.names = FALSE)

oz_data %>% 
  ggplot(aes(x = Chamber, y = log10(OZ))) + 
  geom_boxplot()

oz_data %>% filter(between(Date, mdy("05/06/1991"), mdy("9/23/1991"))) %>% group_by(Chamber) %>% summarise(m = mean(is.na(OZ))) %>% arrange(desc(m))
