library(tidyverse)
library(lubridate)
library(hms)
library(RColorBrewer)

# Read in the OZ data ---------------------------------------------------
ch1 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch01.csv")
ch2 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch02.csv")
ch3 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch03.csv")
ch4 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch04.csv")
ch5 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch05.csv")
ch6 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch06.csv")
ch7 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch07.csv")
ch8 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch08.csv")
ch9 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch09.csv")
ch10 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch10.csv")
ch11 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch11.csv")
ch12 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch12.csv")
ch13 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch13.csv")
ch14 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch14.csv")
ch15 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch15.csv")
ch16 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch16.csv")
ch17 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch17.csv")
ch18 <- read_csv("C:/Users/skoike/Desktop/tidy data/Neufeld/epa corvallis trip/chamber fumigation data/1992/92ch18.csv")

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/clean_chamber.R")

CH1 <- clean_chamber(ch1, 1992) 
CH2 <- clean_chamber(ch2, 1992)         
CH3 <- clean_chamber(ch3, 1992)          
CH4 <- clean_chamber(ch4, 1992)          
CH5 <- clean_chamber(ch5, 1992)         
CH6 <- clean_chamber(ch6, 1992)         
CH7 <- clean_chamber(ch7, 1992)         
CH8 <- clean_chamber(ch8, 1992)          
CH9 <- clean_chamber(ch9, 1992) 
CH10 <- clean_chamber(ch10, 1992)          
CH11 <- clean_chamber(ch11, 1992)         
CH12 <- clean_chamber(ch12, 1992)        
CH13 <- clean_chamber(ch13, 1992)          
CH14 <- clean_chamber(ch14, 1992)          
CH15 <- clean_chamber(ch15, 1992)          
CH16 <- clean_chamber(ch16, 1992)      
CH17 <- clean_chamber(ch17, 1992)        
CH18 <- clean_chamber(ch18, 1992)          

oz_data <- full_join(CH1, CH2) %>% 
  full_join(CH3) %>% 
  full_join(CH4) %>% 
  full_join(CH5) %>% 
  full_join(CH6) %>% 
  full_join(CH7) %>% 
  full_join(CH8) %>% 
  full_join(CH9) %>% 
  full_join(CH10) %>% 
  full_join(CH11) %>% 
  full_join(CH12) %>% 
  full_join(CH13) %>% 
  full_join(CH14) %>% 
  full_join(CH15) %>% 
  full_join(CH16) %>% 
  full_join(CH17) %>%
  full_join(CH18) %>% 
  mutate(Chamber = as_factor(Chamber)) 

summary(oz_data$Date)

#write.csv(oz_data, "1992_oz.csv", row.names = FALSE)

oz_data %>% 
  ggplot() + 
  aes(x = Datetime, y = OZ/1000, color = Chamber) + 
  geom_line() + 
  facet_wrap(. ~ Chamber, nrow = 3) + 
  guides(color = FALSE)

source("C:/Users/skoike/Desktop/tidy data/Neufeld/Seiji's Work/OZ_metrics_Neufeld.R")

exp_days <- max(oz_data$Julian) - min(oz_data$Julian) + 1

oz_metrics <- OZ_metrics_neufeld(oz_data) %>% 
  mutate_if(is.numeric, function(x){x * 92/exp_days})

#write.csv(oz_metrics, "1992_oz_metrics.csv", row.names = FALSE)

oz_data %>% 
  ggplot(aes(x = Chamber, y = log10(OZ))) + 
  geom_boxplot()

oz_data %>% filter(between(Date, mdy("05/04/1992"), mdy("10/09/1992"))) %>% group_by(Chamber) %>% summarise(m = mean(is.na(OZ))) %>% arrange(desc(m))

