# 3-15-21 

bccombined <- 
read.table(
"C:\\Users\\hlee05\\Documents\\ehl\\critdoc2020\\seijizip\\Mean Dry Weight Programs\\Mean Dry Weights\\bc_chamber_mean_data.csv", sep=",",header=T,fill=T)

bccombined$Study.fac <- as.factor(bccombined$Study)

n <- dim(bccombined)
bccombined$is_91 <- rep(0,n[1])
bccombined$is_91[bccombined$Year==1991] <- 1

bccombined$is_92[is.na(bccombined$is_92)] <- 0

plot(bccombined$LOGVOL_bl,bccombined$LOGTOTALDW)
points(bccombined$LOGVOL_bl[bccombined$Study==1992],bccombined$LOGTOTALDW[bccombined$Study==1992],col="red",pch=16)

# 3-15-21

nform1 <- ~ log(a + d*is_92*centered_logvol) + (-(x/b)^c)
nform2 <- ~ log(a + d*is_92*centered_logvol) -(x/b)

nfun1 <- deriv(nform1,
              namevec = c("a", "b", "c", "d"),
              function.arg = c("x", "centered_logvol", "is_92", "a", "b", "c", "d"))

nfun2 <- deriv(nform2,
              namevec = c("a", "b", "d"),
              function.arg = c("x", "centered_logvol", "is_92", "a", "b", "d"))

# 3-15-21 step 1

nm1 <- nlmer(LOGTOTALDW ~ nfun1(w126.12.8.adj, centered_logvol, is_92, a, b, c, d) ~ a + b + c | Study.fac,
             data = bccombined[bccombined$TREAT !="AA",],
             control = nlmerControl( optCtrl = list(maxfun = 2e5)),
             start = c(a = 1, b = 1, c = 1, d = 1))
summary(nm1) 

# 3-15-21 step 2, set c=1

nm2 <- nlmer(LOGTOTALDW ~ nfun2(w126.12.8.adj, centered_logvol, is_92, a, b, d) ~ a + b | Study.fac,
             data = bccombined[bccombined$TREAT !="AA",],
             control = nlmerControl( optCtrl = list(maxfun = 2e5)),
             start = c(a = 1, b = 1, d = 1))
summary(nm2) 


error <- residuals(nm2)
sse <- sum(error^2)
tss <- sum(bccombined$LOGTOTALDW[bccombined$TREAT != "AA"]^2)-mean(bccombined$LOGTOTALDW[bccombined$TREAT != "AA"])^2*length(bccombined$LOGTOTALDW[bccombined$TREAT != "AA"])
pred <- predict(nm2)

r2 <- 1-sse/tss
sse
r2

# 3-15-21 step 1, c=0.96

Nonlinear mixed model fit by maximum likelihood  ['nlmerMod']
Formula: LOGTOTALDW ~ nfun1(w126.12.8.adj, centered_logvol, is_92, a,      b, c, d) ~ a + b + c | Study
   Data: bccombined[bccombined$TREAT != "AA", ]
Control: nlmerControl(optCtrl = list(maxfun = 2e+05))

     AIC      BIC   logLik deviance df.resid 
     5.8     18.7      8.1    -16.2       13 

Scaled residuals: 
     Min       1Q   Median       3Q      Max 
-1.66225 -0.58033  0.04411  0.78856  1.76684 

Random effects:
 Groups   Name Variance  Std.Dev. Corr       
 Study    a    2.179e+01 4.66803             
          b    9.817e+01 9.90805   1.00      
          c    2.246e-04 0.01499  -0.97 -0.97
 Residual      2.398e-02 0.15485             
Number of obs: 24, groups:  Study, 2

Fixed effects:
  Estimate Std. Error t value
a  42.1122     3.9560  10.645
b  50.7668    12.7254   3.989
c   0.9618     0.3335   2.884
d  17.3239     2.6431   6.554

# 3-15-21 step 1, set c=1

Nonlinear mixed model fit by maximum likelihood  ['nlmerMod']
Formula: LOGTOTALDW ~ nfun2(w126.12.8.adj, centered_logvol, is_92, a,      b, d) ~ a + b | Study.fac
   Data: bccombined[bccombined$TREAT != "AA", ]
Control: nlmerControl(optCtrl = list(maxfun = 2e+05))

     AIC      BIC   logLik deviance df.resid 
    -2.2      6.1      8.1    -16.2       17 

Scaled residuals: 
     Min       1Q   Median       3Q      Max 
-1.68303 -0.57440  0.06902  0.78437  1.76657 

Random effects:
 Groups    Name Variance Std.Dev. Corr
 Study.fac a    21.05961 4.5891       
           b    95.23003 9.7586   1.00
 Residual        0.02392 0.1547       
Number of obs: 24, groups:  Study.fac, 2

Fixed effects:
  Estimate Std. Error t value
a   41.911      3.642  11.509
b   49.858      9.266   5.381
d   17.297      2.603   6.645
> sse
[1] 0.530592
> r2
[1] 0.8548444


# end ehl ---------------------------------

library(tidyverse)

study_89 <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Black Cherry/bc_89_mean_data.csv") %>% 
  mutate(Trt = case_when(Trt == 1 ~ "CF",
                         Trt == 2 ~ "1x",
                         Trt == 3 ~ "1.5x",
                         Trt == 4 ~ "2x",
                         TRUE ~ "AA"))
study_89 %>% 
  mutate(W126 = w126.12.8.adj*Exp_days/92) %>%
  group_by(Trt) %>% 
  summarise(m = round(mean(W126), 1))

study_92 <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Black Cherry/bc_92_mean_data.csv") %>% 
  mutate(Trt = case_when(Trt == 1 ~ "CF",
                         Trt == 2 ~ "0.5x",
                         Trt == 3 ~ "1x",
                         Trt == 4 ~ "1.5x",
                         Trt == 5 ~ "2x",
                         TRUE ~ "AA"))

study_92 %>% 
  mutate(W126 = w126.12.8.adj*Exp_days/92) %>%
  group_by(Trt) %>% 
  summarise(m = round(mean(W126), 1))

names(study_89 %>% select(1:10))
names(study_92 %>% select(1:10))

studies %>% group_by(Year, TREAT) %>% tally()

studies <- full_join(study_89, study_92) %>% 
  rename(actual.24 = OZ.24,
         actual.24.adj = OZ.24.adj,
         actual.12.7 = OZ.12.7,
         actual.12.8 = OZ.12.8,
         actual.12.9 = OZ.12.9,
         actual.12.7.adj = OZ.12.7.adj,
         actual.12.8.adj = OZ.12.8.adj,
         actual.12.9.adj = OZ.12.9.adj,
         TREAT = Trt) %>% 
  mutate(Species = "Black Cherry",
         Site = "SMNP",
         Study = as_factor(Year),
         TREAT = as_factor(TREAT))

studies %>% 
  mutate(W126 = w126.12.8.adj*Exp_days/92) %>% 
  group_by(Study, Harvest, Site, TREAT) %>% 
  summarise(m = round(mean(W126), 1))


studies1 <- studies %>% filter(TREAT != "AA")

library(RColorBrewer)

studies1 %>% 
  ggplot() + 
  aes(x = w126.12.8.adj, y = LOGTOTALDW, fill = Study, color = Study) + 
  geom_point(shape = 21, size = 2, color = "black") + 
  scale_fill_brewer(palette = "Set1") + 
  scale_color_brewer(palette = "Set1") +
  geom_smooth(method = "lm", se = FALSE)

studies1 %>% 
  ggplot() + 
  aes(x = LOGVOL_bl, y = LOGTOTALDW, fill = Study, color = Study) + 
  geom_point(shape = 21, size = 2, color = "black") + 
  scale_fill_brewer(palette = "Set1") + 
  scale_color_brewer(palette = "Set1") +
  geom_smooth(method = "lm", se = FALSE)


# Random effects Model ---------------------------------------------------
library(lme4)

BC1 <- studies1 %>% select(Study, w126.12.8.adj, LOGVOL_bl, LOGTOTALDW)

fitmodel <- function(df){lm(LOGTOTALDW ~ LOGVOL_bl, data = df)}

BC1 %>% 
  group_by(Study) %>% 
  nest() %>% 
  mutate(model = map(data, fitmodel),
         tidied = map(model, broom::tidy)) %>% 
  unnest(tidied) %>% 
  filter(term == "LOGVOL_bl")

# Pretty significant logvol term for 1992, need to take that into account 

BC <- studies %>% 
  filter(TREAT != "AA") %>% 
  group_by(Study) %>% 
  mutate(is_92 = ifelse(Study == "1992", 1, 0),
         centered_logvol = LOGVOL_bl - mean(LOGVOL_bl)) %>% 
  select(Species, Study, Site, Year, Harvest, Exp_days, CHAMB, TREAT, ends_with("DW"), 
         is_92, centered_logvol, everything(), -nobs)

BCaa <- full_join(BC, studies %>% filter(TREAT == "AA"))

#write.csv(BCaa, "bc_chamber_mean_data.csv", row.names = FALSE)

# --------------------------------------------------------------
library(lme4)

# Covariate only for 1992

nform <- ~ log(a + d*is_92*centered_logvol) + (-(x/b)^c)

nfun <- deriv(nform,
              namevec = c("a", "b", "c", "d"),
              function.arg = c("x", "centered_logvol", "is_92", "a", "b", "c", "d"))

nm1 <- nlmer(LOGTOTALDW ~ nfun(w126.12.8.adj, centered_logvol, is_92, a, b, c, d) ~ a + b + c | Study,
             data = BC,
             control = nlmerControl(optimizer = "bobyqa", optCtrl = list(maxfun = 2e5)),
             start = c(a = 1, b = 1, c = 1, d = 1))
summary(nm1) # C = 1.0151

aug1 <- broom.mixed::augment(nm1)

aug1 %>% 
  ggplot() + 
  aes(x = .fitted, y = .resid, color = Study) + 
  geom_point() + 
  geom_hline(yintercept = 0, color = "red") + 
  scale_color_brewer(palette = "Set1")

aug1 %>% 
  ggplot() + 
  aes(sample = .resid) + 
  geom_qq() + 
  geom_qq_line()

# Covariate only for 1992, c = 1

nform_a <- ~ log(a + d*is_92*centered_logvol) + (-(x/b))

nfun_a <- deriv(nform_a,
              namevec = c("a", "b", "d"),
              function.arg = c("x", "centered_logvol", "is_92", "a", "b", "d"))

nm_a <- nlmer(LOGTOTALDW ~ nfun_a(w126.12.8.adj, centered_logvol, is_92, a, b, d) ~ a + b | Study,
             data = BC,
             control = nlmerControl(optimizer = "bobyqa", optCtrl = list(maxfun = 2e5)),
             start = c(a = 1, b = 1, d = 1))
summary(nm_a) 

aug_a <- broom.mixed::augment(nm_a)

aug_a %>% 
  ggplot() + 
  aes(x = .fitted, y = .resid, color = Study) + 
  geom_point() + 
  geom_hline(yintercept = 0, color = "red") + 
  scale_color_brewer(palette = "Set1")

aug_a %>% 
  ggplot() + 
  aes(sample = .resid) + 
  geom_qq() + 
  geom_qq_line()

# With covariate both studies

nform2 <- ~ log(a + d*centered_logvol) + (-(x/b)^c)

nfun2 <- deriv(nform2,
               namevec = c("a", "b", "c", "d"),
               function.arg = c("x", "centered_logvol", "a", "b", "c", "d"))

nm2 <- nlmer(LOGTOTALDW ~ nfun2(w126.12.8.adj, centered_logvol, a, b, c, d) ~ a + b + c | Study,
             data = BC,
             control = nlmerControl(optimizer = "bobyqa", 
                                    optCtrl = list(maxfun = 2e5)),
             start = c(a = 1, b = 1, c = 1, d = 1))
summary(nm2) # C = 0.9777

aug2 <- broom.mixed::augment(nm2)

aug2 %>% 
  ggplot() + 
  aes(x = .fitted, y = .resid, color = Study) + 
  geom_point() + 
  geom_hline(yintercept = 0, color = "red") + 
  scale_color_brewer(palette = "Set1")

aug2 %>% 
  ggplot() + 
  aes(sample = .resid) + 
  geom_qq() + 
  geom_qq_line()

# With covariate and fixed C = 1

nform3 <- ~ log(a + d*centered_logvol) + (-(x/b))

nfun3 <- deriv(nform3,
               namevec = c("a", "b", "d"),
               function.arg = c("x", "centered_logvol", "a", "b", "d"))

nm3 <- nlmer(LOGTOTALDW ~ nfun3(w126.12.8.adj, centered_logvol, a, b, d) ~ a + b | Study,
             data = BC,
             control = nlmerControl(optimizer = "bobyqa", 
                                    optCtrl = list(maxfun = 2e5)),
             start = c(a = 1, b = 1, d = 1))
summary(nm3)

aug3 <- broom.mixed::augment(nm3)

aug3 %>% 
  ggplot() + 
  aes(x = .fitted, y = .resid, color = Study) + 
  geom_point() + 
  geom_hline(yintercept = 0, color = "red") + 
  scale_color_brewer(palette = "Set1")

aug3 %>% 
  ggplot() + 
  aes(sample = .resid) + 
  geom_qq() + 
  geom_qq_line()

# No covariate 

nform4 <- ~ log(a) + (-(x/b)^c)

nfun4 <- deriv(nform4,
               namevec = c("a", "b", "c"),
               function.arg = c("x", "a", "b", "c"))

nm4 <- nlmer(LOGTOTALDW ~ nfun4(w126.12.8.adj, a, b, c) ~ a + b + c | Study,
             data = BC,
             control = nlmerControl(optimizer = "bobyqa",
                                    optCtrl = list(maxfun = 2e5)),
             start = c(a = 1, b = 40, c = 1))
summary(nm4)

aug4 <- broom.mixed::augment(nm4)

aug4 %>% 
  ggplot() + 
  aes(x = .fitted, y = .resid, color = Study) + 
  geom_point() + 
  geom_hline(yintercept = 0, color = "red") + 
  scale_color_brewer(palette = "Set1")

aug4 %>% 
  ggplot() + 
  aes(sample = .resid) + 
  geom_qq() + 
  geom_qq_line()

# No covariate 

nform5 <- ~ log(a) + (-(x/b))

nfun5 <- deriv(nform5,
               namevec = c("a", "b"),
               function.arg = c("x", "a", "b"))

nm5 <- nlmer(LOGTOTALDW ~ nfun5(w126.12.8.adj, a, b) ~ a + b | Study,
             data = BC,
             control = nlmerControl(optimizer = "bobyqa",
                                    optCtrl = list(maxfun = 2e5)),
             start = c(a = 1, b = 50))
summary(nm5)

aug5 <- broom.mixed::augment(nm5)

aug5 %>% 
  ggplot() + 
  aes(x = .fitted, y = .resid, color = Study) + 
  geom_point() + 
  geom_hline(yintercept = 0, color = "red") + 
  scale_color_brewer(palette = "Set1")

aug5 %>% 
  ggplot() + 
  aes(sample = .resid) + 
  geom_qq() + 
  geom_qq_line()

# Model Comparison ------------------------------------------------------------

fixef(nm1) # 1992 Covariate
fixef(nm_a) # 1992 Covariate, C = 1
fixef(nm2) # Covariate
fixef(nm3) # Covariate, C = 1
fixef(nm4) # No Covariate
fixef(nm5) # No Covariate, C = 1


mean(aug1$.resid^2) 
mean(aug_a$.resid^2) 
mean(aug2$.resid^2) # Lowest 
mean(aug3$.resid^2) 
mean(aug4$.resid^2)
mean(aug5$.resid^2) 


(SSRes1 <- sum(aug1$.resid^2))
(SSRes_a <- sum(aug_a$.resid^2)) 
(SSRes2 <- sum(aug2$.resid^2)) # Lowest
(SSRes3 <- sum(aug3$.resid^2))
(SSRes4 <- sum(aug4$.resid^2))
(SSRes5 <- sum(aug5$.resid^2))

meanY <- mean(aug2$LOGTOTALDW) 
SStot <- sum((aug2$LOGTOTALDW - meanY)^2) 

(r_sq_1 <- 1 - SSRes1/SStot) 
(r_sq_a <- 1 - SSRes_a/SStot) # Highest R2
(r_sq_2 <- 1 - SSRes2/SStot) 
(r_sq_3 <- 1 - SSRes3/SStot)
(r_sq_4 <- 1 - SSRes4/SStot)
(r_sq_5 <- 1 - SSRes5/SStot)

anova(nm3, nm2) # go with Linear


SSreg <- sum((aug3$.fitted - meanY)^2)


(SSreg)/(SStot)


# Figure 
nform3
broom::tidy(nm3)
(coef_mod <- fixef(nm3))

BC <- BC %>% mutate(adj_y = LOGTOTALDW - log(coef_mod[1] + coef_mod[3]*centered_logvol))


pred <- tibble(w126.12.8.adj = c(seq(0, max(BC$w126.12.8.adj), by = 0.5), max(BC$w126.12.8.adj)),
               adj_y = -(w126.12.8.adj/coef_mod[2]))

BC_plot <- ggplot(BC) + 
  aes(x = w126.12.8.adj, y = adj_y, color = Study) +
  geom_point(size = 2) + 
  scale_color_brewer(palette = "Set1") + 
  geom_line(data = pred, color = "black", size = 0.75)
BC_plot

b <- 1 - exp(-(c(10, 20, 30)/coef_mod[2]))

round(100 * b, 1)

bc_lines <- ggplot_build(BC_plot)$data[[2]] %>% 
  select(x, y) %>% 
  mutate(Species = factor("Black Cherry"))


#write.csv(bc_lines, "bc_lines_harvest1.csv", row.names = FALSE)


w126_frame <- BC %>% 
  group_by(Study) %>% 
  summarize(min_w126 = min(w126.12.8.adj),
            max_w126 = max(w126.12.8.adj)) %>% 
  mutate(x = map2(min_w126, max_w126, seq, by = 0.01)) %>% 
  unnest(cols = x) 

coef_frame <- coef(nm3)[1] %>% 
  as.data.frame() %>% 
  rownames_to_column("Study") %>% 
  select(Study, ends_with("b")) %>% 
  rename(b = Study.b)

BC_lines <- full_join(w126_frame, coef_frame) %>% 
  mutate(y = -(x/b))

nform3

intercept_frame <- coef(nm3)[1] %>% 
  as.data.frame() %>% 
  rownames_to_column("Study") %>% 
  select(Study, Study.a, Study.d)


BC_points <- full_join(BC, intercept_frame) %>% 
  rename(a = Study.a,
         d = Study.d) %>% 
  mutate(adj_y = LOGTOTALDW - log(a + d*centered_logvol))

BC_sub <- BC %>% select(Study) %>% mutate(Model = factor("Population")) %>% slice(1)

pred1_a <- pred %>% 
  mutate(Model = factor("Population")) %>% 
  right_join(BC_sub)

BC_lines <- BC_lines %>% mutate(Model = factor("Individual"))

ggplot(BC_points) + 
  aes(x = w126.12.8.adj, y = adj_y) + 
  geom_point(shape = 21, size = 2, aes(fill = Study)) + 
  scale_fill_brewer(palette = "Set1") + 
  guides(fill = guide_legend(override.aes = list(shape = 21)),
         shape = FALSE) + 
  geom_line(data = BC_lines, aes(x = x, y = y, linetype = Model, color = Study), size = 1) + 
  scale_color_brewer(palette = "Set1") + 
  geom_line(data = pred1_a, aes(x = w126.12.8.adj, y = adj_y, linetype = Model), color = "black", size = 1) 

y_hat <- -(BC_points$w126.12.8.adj/coef_mod[2])
y <- BC_points$adj_y

plot(y, y_hat)
abline(a = 0, b = 1)

SSRes <- sum((y - y_hat)^2)
SSTot <- sum((y - mean(y))^2)

1 - SSRes/SSTot

mean((y - y_hat)^2) 


bc_b <- tibble(b = coef_mod[2], c = 1, Species = "Black Cherry")
bc_b

#write.csv(bc_b, "bc_params.csv", row.names = FALSE)
#write.csv(coef_mod, "bc_all_params.csv")

# Likelihood Confidence Interval -----------------------------------------------

# Step 1: Pull out relevant variables so we don't have to refer to data 

y <- BC$LOGTOTALDW
x <- BC$w126.12.8.adj
Study <- BC$Study
logvol <- BC$centered_logvol

# Step 2: Reparameterize the model so we can create a confidence interval around predicted biomass loss (theta)
nform3

nlform_k <- ~ log(a + d*logvol) + ((x/x0) * log(1 - theta))

nlfun_k <- deriv(nlform_k,
                 namevec = c("a", "d", "theta"),
                 function.arg = c("x", "x0", "logvol", "a", "d", "theta"))

# Step 3: At every break (e.g. 10, 20, 30, etc.), run the model at that fixed point, varying the value of theta


breaks <- c(seq(5, max(x), by = 5), max(x)) # our breaks

# Want a table where the log likelihoods are stored, one row for every theta, one column for every break

theta_vals <- seq(0, 1, by = 0.005) # 101 values for theta

M <- matrix(nrow = length(theta_vals), ncol = length(breaks) + 1)

LL <- as_tibble(M) %>% 
  mutate_all(as.numeric) %>% 
  rename(theta = V1) %>% 
  mutate(theta = theta_vals)

mle <- rep(NA, length(breaks))
ll_0 <- rep(NA, length(breaks))

for(i in 1:(ncol(LL) - 1)){
  
  x0 <- rep(breaks[i], length(x)) # Get the break value of interest
  
  nm_0 <- nlmer(y ~ nlfun_k(x, x0, logvol, a, d, theta) ~ (a|Study) + (theta|Study), # Fit Model to get MLE
                control = nlmerControl(optimizer = "bobyqa", 
                                       optCtrl = list(maxfun = 2e5,
                                                      upper = c(Inf, Inf, Inf, Inf, 1),
                                                      lower = c(-Inf, -Inf, -Inf, -Inf, 0))),
                start = c(a = 1, d = 1, theta = 0.5))
  
  mle[i] <- fixef(nm_0)["theta"] # get the mle for that value of x0
  ll_0[i] <- logLik(nm_0)
  for(j in 1:nrow(LL)){
    
    theta_lim <- as.numeric(LL[j, 1]) # Get theta value
    
    try({nm_k <- nlmer(y ~ nlfun_k(x, x0, logvol, a, d, theta) ~ (a|Study) + (theta|Study),
                       control = nlmerControl(optimizer = "bobyqa", 
                                              optCtrl = list(maxfun = 2e5,
                                                             upper = c(Inf, Inf, Inf, Inf, theta_lim + 0.005),
                                                             lower = c(-Inf, -Inf, -Inf, -Inf, theta_lim - 0.005))),
                       start = c(a = 1, d = 1, theta = theta_lim))}, silent = TRUE)
    # try() keeps loop running if it fails to converge
    
    LL[j, i + 1] <- as.numeric(logLik(nm_k)) # store log-likelihood
  }
}

#write.csv(LL, "bc_LL_profile_harvest1.csv", row.names = FALSE)
#write.csv(ll_0, "bc_ll_hat_harvest1.csv", row.names = FALSE)
#write.csv(mle, "bc_mle_harvest1.csv", row.names = FALSE)

#LL <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Black Cherry/bc_LL_profile_harvest1.csv")
#ll_0 <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Black Cherry/bc_ll_hat_harvest1.csv")
#mle <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Black Cherry/bc_mle_harvest1.csv")

#ll_0 <- as_vector(ll_0)
#mle <- as_vector(mle)

LL
ll_hat <- ll_0 
mle

# Look at the LL profile
# The following figures show what this will look like at each cutoff point
qplot(theta, V2, data = LL, geom = "line") + 
  geom_vline(xintercept = mle[1], color = "red")

qplot(theta, V3, data = LL, geom = "line") + 
  geom_vline(xintercept = mle[2], color = "red") 

qplot(theta, V4, data = LL, geom = "line") + 
  geom_vline(xintercept = mle[3], color = "red")

qplot(theta, V5, data = LL, geom = "line") + 
  geom_vline(xintercept = mle[4], color = "red")

qplot(theta, V6, data = LL, geom = "line") + 
  geom_vline(xintercept = mle[5], color = "red") 

qplot(theta, V7, data = LL, geom = "line") + 
  geom_vline(xintercept = mle[6], color = "red") 

qplot(theta, V8, data = LL, geom = "line") + 
  geom_vline(xintercept = mle[7], color = "red")


LL_1 <- LL 


# Et Cetera...


LL_2 <- LL_1 %>% pivot_longer(cols = -theta, names_to = "V", values_to = "LL")

ll_hat_frame <- tibble(V = colnames(LL)[-1], ll_hat)

q <- qchisq(0.95, 1) # Critical value: LR ~ chi-sq(1)

LL_4 <- full_join(LL_2, ll_hat_frame) %>%
  group_by(V) %>% 
  mutate(LR = 2 * (ll_hat - LL)) %>% # LR statistic
  filter(LR <= q) %>% # Keep the values where we would not reject the null hypothesis
  slice(1, n()) %>% # Get the maximum and minimum of these theta values 
  select(V, theta) %>% 
  mutate(y = c("ymin", "ymax")) %>% 
  pivot_wider(names_from = y, values_from = theta) %>%
  mutate(V = str_replace(V, "V", ""),
         V = as.numeric(V)) %>% 
  arrange(V)

LL_4

# adjust for the fact that the mle from above does not correspond exactly with original model

pred_0 <- 1 - exp(-(breaks/coef_mod[2]))

adj <- mle - pred_0

plot(mle, pred_0)
abline(a = 0, b = 1)

LL_4$adj <- adj 

LL_5 <- LL_4 %>%
  ungroup() %>% 
  mutate(ymin = ymin - adj,
         ymax = ymax - adj,
         x = breaks) %>% 
  select(-adj, -V)

LL_5

LL_6 <- LL_5 %>% 
  add_row(ymin = 0, ymax = 0, x = 0, .before = 1)

plot(LL_6$x, LL_6$ymax, type = "l", xlim = c(0, 40))
lines(LL_6$x, LL_6$ymin)
lines(breaks, pred_0, lty = 2)


# Write file

write.csv(LL_6, "bc_para_ci.csv", row.names = FALSE)
