library(tidyverse)

# Likelihood Confidence Bands
bc_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Black Cherry/bc_bands.csv")
df_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Douglas Fir/df_bands.csv") %>% 
  mutate(Species = "Douglas-fir")
ewp_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Eastern White Pine/ewp_bands.csv")
pp_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Ponderosa Pine Supplement/pp_bands.csv")
qa_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Quaking Aspen/qa_bands.csv")
ra_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Red Alder/ra_bands.csv")
rm_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Red Maple/rm_bands.csv")
sm_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Sugar Maple/sm_bands.csv")
tp_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Tulip Poplar/tp_bands.csv")
vp_bands <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Virginia Pine/vp_bands.csv")

# New Species
ehem_lines <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Eastern Hemlock/ehem_bands.csv") 
sum_lines <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Sumac/sum_bands.csv") %>% 
  mutate(Species = "Winged Sumac")
sg_lines <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Sweetgum/sg_bands.csv")
syc_lines <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Sycamore/syc_bands.csv")
tmp_lines <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Table Mountain Pine/tmp_bands.csv")
yep_lines <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Yellow Buckeye/ybe_bands.csv")
chest_lines <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Chestnut Oak/chest_bands.csv")


all_bands <- full_join(bc_bands, df_bands) %>% 
  full_join(ewp_bands) %>% 
  full_join(pp_bands) %>% 
  full_join(qa_bands) %>% 
  full_join(ra_bands) %>% 
  full_join(rm_bands) %>% 
  full_join(sm_bands) %>% 
  full_join(tp_bands) %>% 
  full_join(vp_bands) %>% 
  #full_join(ehem_lines) %>% 
  full_join(sum_lines) %>% 
  full_join(sg_lines) %>% 
  full_join(syc_lines) %>% 
  full_join(tmp_lines) %>%
  full_join(yep_lines) %>%
  full_join(chest_lines) 

# Biomass Loss Figure
ggplot(all_bands) + 
  aes(x = x, y = y) + 
  geom_line(size = 1) + 
  scale_color_manual(values = "black") +
  scale_fill_manual(values = "grey") +
  guides(color = FALSE, fill = FALSE) +
  geom_ribbon(aes(ymin = ymin, ymax = ymax), alpha = 0.25, na.rm = TRUE) + 
  facet_wrap(. ~ Species, nrow = 4) + 
  scale_x_continuous(breaks = seq(0, 110, by = 20)) + 
  scale_y_continuous(breaks = seq(-60, 100, by = 20)) + 
  xlab("W126 (ppm-h)") + 
  ylab("Predicted Relative Biomass Loss (%)") + 
  theme_bw()

#ggsave("biomass_loss.png", width = 12, height = 9, units = "in")

all_bands %>% 
  select(Species, x, y) %>% 
  filter(x %in% c(10, 20, 30, 40, 50)) %>% 
  pivot_wider(names_from = x, values_from = y) %>% 
  mutate_if(is.numeric, function(x){round(x, 1)})


all_bands %>% 
  select(-y) %>% 
  filter(x %in% c(10, 20, 30, 40, 50)) %>% 
  pivot_wider(names_from = x, values_from = c(ymin, ymax)) %>% 
  arrange(Species) %>% 
  select(Species, ends_with("10"), ends_with("20"), ends_with("30"), ends_with("40"), ends_with("50")) %>% 
  mutate_if(is.numeric, function(x){round(x, 1)})
