library(tidyverse)

bc_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Black Cherry/bc_params.csv")
df_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Douglas Fir/df_params.csv")
ewp_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Eastern White Pine/ewp_params.csv")
pp_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Ponderosa Pine Supplement/pp_params.csv")
qa_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Quaking Aspen/qa_params.csv")
ra_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Red Alder/ra_params.csv")
rm_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Red Maple/rm_params.csv")
sm_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Sugar Maple/sm_params.csv")
tp_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Tulip Poplar/tp_params.csv")
vp_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Virginia Pine/vp_params.csv")

#New Species
#ehem_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Eastern Hemlock/ehem_params.csv")
sum_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Sumac/sum_params.csv") %>% 
  mutate(Species = "Winged Sumac")
sg_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Sweetgum/sg_params.csv")
syc_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Sycamore/syc_params.csv")
tmp_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Table Mountain Pine/tmp_params.csv")
ybe_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Yellow Buckeye/ybe_params.csv")
chest_params <- read_csv("C:/Users/skoike/Desktop/Reanalysis/New Species/Chestnut Oak/chest_params.csv")


all_params <- full_join(bc_params, df_params) %>% 
  full_join(ewp_params) %>% 
  full_join(pp_params) %>% 
  full_join(qa_params) %>% 
  full_join(ra_params) %>% 
  full_join(rm_params) %>% 
  full_join(sm_params) %>% 
  full_join(tp_params) %>% 
  full_join(vp_params)  %>% 
  #full_join(ehem_params) %>% 
  full_join(sum_params) %>% 
  full_join(sg_params) %>% 
  full_join(syc_params) %>% 
  full_join(tmp_params) %>%
  full_join(ybe_params) %>% 
  full_join(chest_params) %>% 
  select(Species, b, c) %>% 
  arrange(Species)

all_params %>% 
  mutate(b = round(b), c = round(c, 1))

oz_lvl <- function(b, c, percentage){
  p <- percentage/100
  w126 <- b*(-log(1 - p))^(1/c)
  return(w126)
}

a <- all_params %>% 
  rowwise() %>% 
  mutate(w126 = oz_lvl(b, c, 6),
         w126 = ifelse(w126 < 0, NA, w126))
a

a %>% arrange(w126)
