library(tidyverse)

# Read in predictive curve
SM <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Sugar Maple/sm_lines.csv")

# Read Parametric CI

para_ci <- read_csv("C:/Users/skoike/Desktop/Reanalysis/Sugar Maple/sm_para_ci.csv") %>% 
  mutate_at(vars(-x), function(x){x*100}) %>% 
  arrange(x)

new_pred <- data.frame(x = SM$x, new_ymin = 0)

# Smooth ymax

plot(para_ci$x, para_ci$ymax)

y_upper_fcn <- nls(ymax ~ f(x, a, b), data = para_ci[-c(14, 15, 16, 17), ],
                   start = list(a = 1, b = 1))
new_ymax <- predict(y_upper_fcn, newdata = new_pred)
new_pred$new_ymax <- new_ymax


plot(para_ci$x, para_ci$ymax)
lines(new_pred$x, new_pred$new_ymax)


ci_plot <- ggplot(new_pred) + 
  aes(x = x) + 
  geom_ribbon(aes(ymin = new_ymin, ymax = new_ymax), alpha = 0.3) +
  geom_line(data = SM, aes(x = x, y = 100*(1 - exp(y))), size = 1, color = "blue") + 
  ylab("Predicted Relative Biomass Loss (%)") + 
  xlab("W126 (ppm-h)") + 
  scale_y_continuous(breaks = seq(0, 100, by = 20)) + 
  scale_x_continuous(breaks = seq(0, 100, by = 10))

ci_plot

# Export data for grid plot
#ggplot_build(ci_plot) data[[1]] has band info, data[[2]] has predicted curve

bands <- ggplot_build(ci_plot)$data[[1]] %>% select(x, ymin, ymax) %>% mutate(x = round(x, 7))
pred_curve <- ggplot_build(ci_plot)$data[[2]] %>% select(x, y) %>% mutate(x = round(x, 7))

sm_info <- full_join(bands, pred_curve) %>% 
  mutate(Species = factor("Sugar Maple")) %>% 
  select(Species, x, y, ymin, ymax) 

#write.csv(sm_info, "sm_bands.csv", row.names = FALSE)

